backoffice/src/missions/urls.py
urlpatterns = []

backoffice/src/seawatch_registration/urls.py
from django.urls import path

urlpatterns = []

backoffice/src/seawatch_registration/models.py
from django import forms
from django.db import models
from django.db.models.fields import BooleanField
from django.utils.translation import gettext_lazy as _


class ShortTextField(models.TextField):
    description = _("TextField that uses a forms.TextInput by default")

    def formfield(self, **kwargs):
        return super().formfield(
            **{
                **({} if self.choices is not None else {"widget": forms.TextInput}),
                **kwargs,
            }
        )


class Position(models.Model):
    class Meta:
        ordering = ["key"]

    id = models.AutoField(primary_key=True)

    key = ShortTextField(unique=True)
    name = ShortTextField(verbose_name=_("Name"))

    open_for_applications = BooleanField()

    def __str__(self):
        return self.name

backoffice/src/volunteers/models.py
import datetime
from typing import TYPE_CHECKING

from django.contrib.contenttypes.fields import GenericRelation
from django.core.exceptions import ValidationError
from django.db import models
from django.utils.translation import gettext as _
from phonenumber_field.modelfields import PhoneNumberField
from planner_common import data
from planner_common.models import Gender

from applications.models import Application, PositionDecision, nationalities_separator
from history.models import HistoryItem
from seawatch_registration.models import Position, ShortTextField

if TYPE_CHECKING:
    from django.db.models.manager import RelatedManager

    from missions.models import Availability

valid_language_codes = {l["code"] for l in data.languages}


def validate_languages_dict(value):
    if type(value) != dict:
        raise ValidationError("languages must be a dict")
    for code, level in value.items():
        if code not in valid_language_codes:
            raise ValidationError(
                _("%(code)r is not a valid language code"), params={"code": code}
            )
        if level not in [0, 1, 2, 3]:
            raise ValidationError(
                _("%(level)r is not a valid language level"), params={"level": level}
            )


class VolunteerManager(models.Manager):
    def create_from_application(self, application: Application):
        obj = self.create(
            first_name=application.first_name,
            last_name=application.last_name,
            phone_number=application.phone_number,
            email=application.email,
            date_of_birth=application.date_of_birth,
            gender=application.gender,
            certificates=application.certificates,
            languages={l.code: l.points for l in application.languages.all()},
            nationalities=application.nationalities.split(nationalities_separator),
            application=application,
        )
        obj.positions.set(
            pd.position
            for pd in application.position_decisions.filter(
                decision=PositionDecision.Decision.ACCEPT
            )
        )

        return obj


class Volunteer(models.Model):
    objects: VolunteerManager = VolunteerManager()

    history = GenericRelation(HistoryItem)  # type: ignore

    ### fields

    id = models.AutoField(primary_key=True)
    first_name = ShortTextField()
    last_name = ShortTextField()
    phone_number = PhoneNumberField()
    # TODO: Propper Email field
    email = ShortTextField()

    date_of_birth = models.DateField()
    gender = ShortTextField(choices=Gender.choices)

    positions = models.ManyToManyField(Position)
    certificates = models.JSONField(blank=True)  # ["drivers-license", "more-things"]
    languages = models.JSONField(
        validators=[validate_languages_dict]
    )  # {"deu": 3, "eng": 2}
    nationalities = models.JSONField()  # ["jp", "de"]

    application = models.ForeignKey(Application, on_delete=models.PROTECT)

    if TYPE_CHECKING:
        availability_set = RelatedManager[Availability]()

    @property
    def name(self):
        return f"{self.first_name} {self.last_name}".strip()

    def __str__(self):
        return f"<Volunteer: {self.name}>"

    def to_history_dict(self):
        return {
            "first_name": self.first_name,
            "last_name": self.last_name,
            "phone_number": self.phone_number,
            "email": self.email,
            "date_of_birth": self.date_of_birth.isoformat(),
            "gender": self.gender,
            "positions": ",".join(p.key for p in self.positions.all()),
            "certificates": self.certificates,
            "languages": self.languages,
            "nationalities": [n.lower() for n in self.nationalities],
        }


class MalformedInquiry(models.Model):
    class Meta:
        verbose_name_plural = "malformed inquiries"

    id = models.AutoField(primary_key=True)
    submitted_data = models.JSONField()
    uid = ShortTextField()
    created = models.DateTimeField(editable=False)

    def save(self, *args, **kwargs):
        """on save, create timestamp"""
        if not self.id and self.created is None:
            self.created = datetime.datetime.now(datetime.timezone.utc)
        return super().save(*args, **kwargs)

backoffice/src/applications/views.py
import logging
from datetime import datetime
from typing import Any, Dict, cast
from urllib.parse import urlencode

from django.conf import settings
from django.contrib import messages
from django.contrib.auth.decorators import permission_required
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.contrib.auth.models import User
from django.core.mail import send_mail
from django.db import transaction
from django.db.models import Q
from django.http.request import HttpRequest
from django.http.response import (
    HttpResponse,
    HttpResponseBadRequest,
    HttpResponseNotFound,
    HttpResponseRedirect,
)
from django.shortcuts import get_object_or_404
from django.template.loader import render_to_string
from django.template.response import TemplateResponse
from django.urls import reverse, reverse_lazy
from django.utils import timezone
from django.utils.translation import gettext as _
from django.views.decorators.http import require_POST
from django.views.generic import DeleteView
from django.views.generic.base import View
from django.views.generic.edit import UpdateView
from django_tables2 import SingleTableView

from applications.templatetags.applications_tags import (
    rejection_mail_body,
    rejection_mail_subject,
)
from history.models import HistoryItem
from missions.models import Availability
from seawatch_registration.models import Position
from volunteers.management.commands.import_inquiries import (
    Command as ImportInquiriesCommand,
)
from volunteers.models import Volunteer

from . import forms
from .management.commands.import_applications import (
    Command as ImportApplicationsCommand,
)
from .models import Application, Import, PositionDecision
from .tables import OpenApplicationsTable

logger = logging.getLogger(__name__)


def get_position_or_none(key):
    try:
        return Position.objects.get(key=key)
    except Position.DoesNotExist:
        return None


@require_POST
def add_comment(request, pk):
    application = get_object_or_404(Application, pk=pk)
    text = request.POST.get("comment")
    if not text:
        return HttpResponseBadRequest()

    comment = application.comments.create(
        author=request.user,
        text=text,
    )

    return TemplateResponse(
        request,
        "applications/application_form_add_comment.html",
        {"comment": comment, "application": application},
    )


class ApplicationListView(PermissionRequiredMixin, SingleTableView):
    model = Application
    table_class = OpenApplicationsTable
    permission_required = "applications.view_application"

    search = None

    def get_queryset(self):
        qs = super().get_queryset()

        position = self.request.GET.get("position")
        if position:
            qs = qs.filter(positions__key=position)

        self.search = self.request.GET.get("search")
        if self.search:
            search_without_spaces = self.search.split(" ")
            for word in search_without_spaces:
                qs = qs.filter(
                    Q(first_name__icontains=word) | Q(last_name__icontains=word)
                )
        return qs

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["last_import"] = Import.get_last_imported()
        context["positions"] = [
            {"object": pos, "link": self._build_link(pos)}
            for pos in Position.objects.all().order_by("name")
        ]
        context["search"] = self.search or ""
        context["selected_position"] = get_position_or_none(
            self.request.GET.get("position")
        )
        context["all_positions_link"] = (
            f'?{urlencode({"search":self.search})}' if self.search else "?"
        )
        return context

    def _build_link(self, pos):
        query_search = {"position": pos.key}
        if self.search:
            query_search["search"] = self.search
        return f"?{urlencode(query_search)}"

    def post(self, request, *args, **kwargs):
        try:
            apps_before_import = Application.objects.count()
            unknown_avail_before_import = Availability.objects.filter(
                availability=Availability.UNKNOWN
            ).count()
            ImportApplicationsCommand().handle()
            ImportInquiriesCommand().handle()
            new_app_count = Application.objects.count() - apps_before_import
            new_avail_count = (
                unknown_avail_before_import
                - Availability.objects.filter(availability=Availability.UNKNOWN).count()
            )
            info_message = f"Import succeeded. Found {new_app_count} new applications"
            if new_avail_count > 0:
                info_message += f" and {new_avail_count} new status updates."
            messages.info(request, info_message)
        except:
            logger.exception(
                "Importing applications failed", extra={"request": request}
            )
            messages.error(
                request,
                "An error occured during import. Sorry about that. "
                "The administrator has alread been notified.",
            )
        return HttpResponseRedirect(reverse("application_list"))


class ApplicationUpdateView(PermissionRequiredMixin, UpdateView):
    model = Application
    permission_required = "applications.view_application"
    form_class = forms.ApplicationForm

    object: Application
    __original_history_dict: dict

    def post(self, *args, **kwargs):
        with transaction.atomic():
            return super().post(*args, **kwargs)

    def get_object(self):
        application = cast(Application, super().get_object())
        self.__original_history_dict = application.to_history_dict()
        return application

    def form_valid(self, form):
        response = super().form_valid(form)
        HistoryItem.objects.create_from_dicts(
            self.object,
            old=self.__original_history_dict,
            new=self.object.to_history_dict(),
        )
        messages.success(self.request, _("The application was successfully updated"))
        return response


class ApplicationDeleteView(PermissionRequiredMixin, DeleteView):
    model = Application
    success_url = reverse_lazy("application_list")
    permission_required = "applications.delete_application"

    object: Application

    # overridable in tests
    send_mail = staticmethod(lambda *a, **k: send_mail(*a, **k))

    def post(self, request, *args, **kwargs):
        should_send_mail_str = request.POST.get("send_email")
        if should_send_mail_str not in ["true", "false"]:
            return HttpResponseBadRequest("invalid or missing send_email parameter")

        self.should_send_mail = should_send_mail_str == "true"

        with transaction.atomic():
            return super().post(request, *args, **kwargs)

    def form_valid(self, form):
        # DeleteView includes FormMixin which provides form_valid and object, but django-stubs isn't
        # up to date on this yet: https://github.com/typeddjango/django-stubs/pull/849
        application = self.object

        mail_data = None
        if self.should_send_mail:
            # need to do this before we delete
            mail_data = {
                "subject": rejection_mail_subject(application),
                "message": rejection_mail_body(application),
            }

        response = super().form_valid(form)  # type: ignore

        messages.info(
            self.request, f"{application.first_name}'s application has been deleted."
        )

        if mail_data:
            mail_context = {"application": application}
            self.send_mail(
                subject=mail_data["subject"],
                message=mail_data["message"],
                from_email=settings.EXTERNAL_EMAIL_FROM,
                recipient_list=[application.email],
            )
        return response


class ApplicationAcceptView(PermissionRequiredMixin, View):
    permission_required = [
        "volunteers.add_volunteer",
    ]

    # overridable in tests
    send_mail = staticmethod(lambda *a, **k: send_mail(*a, **k))

    def get(self, request: HttpRequest, pk):
        application = get_object_or_404(Application, pk=pk)
        if not application.has_all_positions_decided:
            return self._handle_application_with_undecided_positions(application)

        return TemplateResponse(
            request,
            "applications/application_confirm_accept.html",
            context={"application": application},
        )

    def post(self, request: HttpRequest, pk):
        with transaction.atomic():
            application = get_object_or_404(Application, pk=pk)

            if not application.has_all_positions_decided:
                return self._handle_application_with_undecided_positions(application)

            original_history_dict = application.to_history_dict()

            Volunteer.objects.create_from_application(application)
            application.accepted = timezone.now()
            application.save()

            HistoryItem.objects.create_from_dicts(
                application,
                old=original_history_dict,
                new=application.to_history_dict(),
            )

            mail_context = {"application": application}
            try:
                self.send_mail(
                    subject=render_to_string(
                        "applications/mail/accept_application.subject.txt",
                        mail_context,
                    ).strip(),
                    message=render_to_string(
                        "applications/mail/accept_application.message.txt",
                        mail_context,
                    ).strip(),
                    from_email=settings.EXTERNAL_EMAIL_FROM,
                    recipient_list=[application.email],
                )
            except:
                logger.exception(

backoffice/src/seawatch_registration/templates/base-registration.html
{% load bootstrap4 %}
{% load static %}
{% load fontawesome_5 %}
<!doctype html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
        <link rel="shortcut icon" type="image/x-icon" href="{% static 'seawatch_registration/images/favicon.png' %}">

        {% bootstrap_css %}
        {% fontawesome_5_static %}

        <link rel="stylesheet" href="{% static 'seawatch_registration/css/seawatch_registration.css' %}">

        <title>{% block title %}SeaWatch{% endblock %}</title>

        {% block head %}{% endblock %}
        {% bootstrap_javascript jquery="slim" %}
    </head>
    <body{% include "body_env_warning.htmlpart" %}>
        {% include 'partials/messages.html' %}
        <div class="login-container">
            <div class="login-background"></div>
            <div class="login-logo"></div>
            <div class="login-content">
                {% block content %}{% endblock %}
            </div>
        </div>
    </body>
</html>
{% load i18n %}

backoffice/src/seawatch_registration/templates/base.html
{% load bootstrap4 %}
{% load static %}
{% load fontawesome_5 %}
<!doctype html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
        <link rel="shortcut icon" type="image/x-icon" href="{% static 'seawatch_registration/images/favicon.png' %}">

        {% bootstrap_css %}
        {% fontawesome_5_static %}

        <link rel="stylesheet" href="{% static 'seawatch_registration/css/seawatch_registration.css' %}">
        <link rel=stylesheet href="{% static "volunteers/autosave-input.css" %}"></link>
        {% block extra_css %}{% endblock %}

        <title>{% block title %}SeaWatch{% endblock %}</title>

        {% block head %}{% endblock %}
        {% bootstrap_javascript jquery="slim" %}
    </head>
    <body{% include "body_env_warning.htmlpart" %} data-csrf-token="{{ csrf_token }}">
        {% include 'navbar.html' %}

        <div class="container">
            {% include 'partials/messages.html' %}

            {% block content %}{% endblock %}
        </div>
        {% block extra_body_content %}{% endblock %}
        <script src="{% static 'vendor/htmx.js' %}"></script>
        <script src="{% static 'vendor/htmx/json-enc.js' %}"></script>
        <script src="{% static 'planner.js' %}" type="module"></script>
        <script>
            document.body.addEventListener('htmx:configRequest', (e) => {
                e.detail.headers['X-CSRFToken'] = document.body.dataset.csrfToken;
            })
        </script>
        {% block extra_scripts %}{% endblock %}
    </body>
</html>

backoffice/src/seawatch_registration/templates/confirm-delete.html
{% extends 'base-registration.html' %}
{% load bootstrap4 %}
{% load i18n %}

{% block title %}{{ view.title }} | Seawatch Registration{% endblock %}

{% block content %}
    <h1>{{ view.title }}</h1>

    <form method="post">
        {% csrf_token %}
        <p>{% blocktrans with object=object%}Are you sure you want to delete "{{ object }}"?{% endblocktrans %}</p>
        <input class="btn btn-primary" type="submit" value="{% trans 'Confirm' %}">
    </form>
{% endblock %}

backoffice/src/seawatch_registration/templates/dialog.html
{% load static seawatch_registration_tags %}

<dialog{%block dialog_attrs %}{% endblock %}>
    <div class="modal-header">
        <form method="dialog" class="close-button-form"><button type="submit">{% include "vendor/material-icons/close.svg" %}</button></form>
        {% block header %}{% endblock %}
    </div>
    <div class="modal-body">{% block body %}{% endblock %}</div>
    <menu>{% block buttons %}{% endblock %}</menu>
</dialog>

backoffice/src/seawatch_registration/templates/form.html
{% extends 'base-registration.html' %}
{% load bootstrap4 %}

{% block title %}{{ view.title }} | Seawatch Registration{% endblock %}

{% block content %}
    <h1>{{ view.title }}</h1>
    {% if success or request.GET.success %}
        <div class="alert alert-success" role="alert">
            {{ view.success_message }}
            {{ view.success_alert }}
        </div>
    {% endif %}
    {% if form.errors %}
        <div class="alert alert-danger" role="alert">
            {{ view.error_message }}
        </div>
    {% endif %}

    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {% bootstrap_form form %}

        {% buttons %}
            <button type="submit" class="btn btn-primary">{{ view.submit_button }}</button>
            {% if view.can_be_skipped %}
                <button form="skip_form" name="skip" value="skip" type="submit"
                        class="btn btn-link">{{ view.skip_button_text }}</button>
            {% endif %}
        {% endbuttons %}
    </form>

    {% if view.can_be_skipped %}
        <form method="post" id="skip_form">
            {% csrf_token %}
        </form>
    {% endif %}
{% endblock %}

backoffice/src/seawatch_registration/templates/navbar.html
{% load bootstrap4 %}
{% load static %}
{% load i18n %}
{% load seawatch_registration_tags %}


{% with url_name=request.resolver_match.url_name %}
<nav class="navbar navbar-dark navbar-expand-lg">
    <div class="container">
        <a class="navbar-brand" href="{% url 'index' %}">
            <img src="{% static 'seawatch_registration/images/logo.png' %}" width="75" height="75"
                 class="d-inline-block align-top mr-2" alt="">
            <!--Sea Watch-->
        </a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav"
                aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
            <ul class="nav navbar-nav ml-auto">
                {% if request.user.is_authenticated %}
                    {% if perms.applications.view_application %}
                        <li class="nav-item">
                            <a class="nav-link {% if url_name == 'application_list' %}active{% endif %}"
                               href="{% url 'application_list' %}">{% trans "Applications" %}</a>
                        </li>
                    {% endif %}
                    {% if perms.volunteers.view_volunteer %}
                        <li class="nav-item">
                            <a class="nav-link {% if url_name == 'volunteer_list' %}active{% endif %}"
                               href="{% url 'volunteer_list' %}">{% trans "Volunteers" %}</a>
                        </li>
                    {% endif %}
                {% endif %}
                {% if request.user.is_authenticated %}
                    {% feedback_url as feedback_url %}
                    {% if feedback_url %}
                        <li class="nav-item">
                            <a class="nav-link btn btn-primary" target="_blank" rel="noopener noreferrer" href="{{ feedback_url }}">
                                <i class="fa fa-comments"></i> Feedback
                            </a>
                        </li>
                    {% endif %}
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button"
                           data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            {{ request.user.first_name }} {{ request.user.last_name }}
                        </a>
                        <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                            {% if request.user.profile %}
                                <a class="dropdown-item" href="{% url 'profile_detail' %}">{% trans "Show profile" %}</a>
                                <a class="dropdown-item" href="{% url 'registration_process' %}">{% trans "Registration Status" %}</a>
                                <div class="dropdown-divider"></div>
                            {% endif %}
                            <a class="dropdown-item" href="{% url 'logout' %}">{% trans 'Logout' %}</a>
                        </div>
                    </li>
                {% else %}
                    <li class="nav-item">
                        <a class="nav-link
                                {% url 'login' as login_url %}{% if request.get_full_path == login_url %}active{% endif %}"
                           href="{% url 'login' %}">{% trans "Login" %}</a>
                    </li>
                {% endif %}
            </ul>
        </div>
    </div>
</nav>
{% endwith %}

backoffice/src/seawatch_registration/templates/pagination.html
{% load i18n %}

{% if is_paginated %}
    <nav aria-label="...">
        <ul class="pagination justify-content-center">
            {% if page_obj.has_previous %}
            <li class="page-item">
                <a class="page-link" href="{{ request.path }}?page={{ page_obj.previous_page_number }}">{% trans 'Previous' %}</a>
            </li>
            {% else %}
            <li class="page-item disabled">
                <span class="page-link">{% trans 'Previous' %}</span>
            </li>
            {% endif %}
            {% for number in paginator.page_range %}
                {% if page_obj.number == number %}
                <li class="page-item active">
                    <span class="page-link">
                        {{ page_obj.number }}
                    <span class="sr-only">({% trans 'current' %})</span>
                    </span>
                </li>
                {% else %}
                <li class="page-item"><a class="page-link" href="{{ request.path }}?page={{ number }}">{{ number }}</a></li>
                {% endif %}
            {% endfor %}
            {% if page_obj.has_next %}
            <li class="page-item">
                <a class="page-link" href="{{ request.path }}?page={{ page_obj.next_page_number }}">{% trans 'Next' %}</a>
            </li>
            {% else %}
            <li class="page-item disabled">
                <span class="page-link">{% trans 'Next' %}</span>
            </li>
            {% endif %}
        </ul>
    </nav>
    {% endif %}

backoffice/src/seawatch_registration/templates/styleguide.html
{% extends "base.html" %} {% block title %}Backoffice styleguide{% endblock %}
{% block content %}
<h1>Styleguide</h1>
<p>
  This page showcases our visual components. This way, we can develop them without
  having to care about the data. This page also serves as the single reference: For
  example, all tables should look like this one, and if variants are necessary, the
  rationale and implementation will be described on this page.
</p>

<h2>Links</h2>

<p>This is a <a href="#">Link</a>.</p>

<h2>Tables</h2>

<p>
  See the MDN on
  <a href="https://developer.mozilla.org/en-US/docs/Learn/HTML/Tables/Basics"
    >Tables basics</a
  >
  and
  <a
    href="https://developer.mozilla.org/en-US/docs/Learn/CSS/Building_blocks/Styling_tables"
    >Styling Tables</a
  >.
</p>

<h3>Header for subsection</h3>

<p>
  Note that tables probably should have a min-width style set to provide some basic
  support for mobile/small screen devices
</p>

<table class="table">
  <caption>
    A summary of the UK's most famous punk bands
  </caption>
  <thead>
    <tr>
      <th scope="col" class="orderable desc">Band</th>
      <th scope="col" class="orderable">Year formed</th>
      <th scope="col">No. of Albums</th>
      <th scope="col">Most famous song</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th scope="row">Buzzcocks</th>
      <td>1976</td>
      <td>9</td>
      <td class="dot-green">Ever fallen in love (with someone you shouldn't've)</td>
    </tr>
    <tr>
      <th scope="row">The Clash</th>
      <td>1976</td>
      <td>6</td>
      <td class="dot-gray">London Calling</td>
    </tr>
    <tr>
      <th scope="row">The Damned</th>
      <td>1976</td>
      <td>10</td>
      <td class="dot-yellow">Smash it up</td>
    </tr>
    <tr>
      <td class="row-header">Sex Pistols</td>
      <td>1975</td>
      <td>1</td>
      <td>Anarchy in the UK</td>
    </tr>
    <tr>
      <th scope="row">Sham 69</th>
      <td>1976</td>
      <td>13</td>
      <td>If The Kids Are United</td>
    </tr>
    <tr>
      <th scope="row">Siouxsie and the Banshees</th>
      <td>1976</td>
      <td>11</td>
      <td>
        <ul>
          <li class="dot-green">List in table</li>
          <li>Li without dot</li>
          <li class="dot-gray">with</li>
          <li class="dot-yellow">dots</li>
        </ul>
      </td>
    </tr>
    <tr>
      <th scope="row">Stiff Little Fingers</th>
      <td>1977</td>
      <td>10</td>
      <td>Suspect Device</td>
    </tr>
    <tr>
      <th scope="row">The Stranglers</th>
      <td>1974</td>
      <td>17</td>
      <td>No More Heroes</td>
    </tr>
  </tbody>
  <tfoot>
    <tr>
      <th scope="row" colspan="2">Total albums</th>
      <td colspan="2">77</td>
    </tr>
  </tfoot>
</table>

<h3>A table without data</h3>

<table class="table">
  <caption>
    A summary of the UK's best punk bands
  </caption>
  <thead>
    <tr>
      <th scope="col" class="orderable desc">Band</th>
      <th scope="col" class="orderable">Year formed</th>
      <th scope="col">No. of Albums</th>
      <th scope="col">Most famous song</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td class="empty-table-message" colspan="4">
        Punk has been dead for a while. Get over it.
      </td>
    </tr>
  </tbody>
</table>

<h3>A table with a button</h3>

Use this when you neet to have a button next to your table.

<div class="table-with-button">
  <div class="table-container">
    <table class="table">
      <caption>
        A summary of the UK's best punk bands
      </caption>
      <thead>
        <tr>
          <th scope="col" class="orderable desc">Band</th>
          <th scope="col" class="orderable">Year formed</th>
          <th scope="col">No. of Albums</th>
          <th scope="col">Most famous song</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td class="empty-table-message" colspan="4">
            Punk has been dead for a while. Get over it.
          </td>
        </tr>
      </tbody>
    </table>
  </div>
  <div class="button-container">
    <form action="#" method="get">
      <input type="submit" class="button" value="Submit" />
      <label class="button-label">Don't click on this button</label>
    </form>
  </div>
</div>

Use this if you need a pop up

<button id="sensitiveAction" class="button">Sensitive action</button>
<dialog id="confirmationDialog" class="confirmation">
  <form method="dialog">
    <div class="modal-header">Sure you want to execute this?</div>
    <div class="modal-body">
      If confirmed, something will happen. And you want to make sure the user
      understands that!
    </div>
    <menu>
      <button value="cancel">Cancel</button>
      <button value="confirm">Confirm</button>
    </menu>
  </form>
</dialog>
<script>
  // Short script to open confirmation modal and forward to deletion page if confirmed
  var actionButton = document.getElementById("sensitiveAction");
  var confirmationDialog = document.getElementById("confirmationDialog");

  // Open modal
  actionButton.addEventListener("click", function onOpen() {
    if (typeof confirmationDialog.showModal === "function") {
      confirmationDialog.showModal();
    } else {
      console.log("modal not supported by browser");
    }
  });
  confirmationDialog.addEventListener("close", function onClose() {
    if (confirmationDialog.returnValue === "confirm") {
      console.log("confirmed");
    }
  });
</script>
{% endblock %}
The following is recognized to be compatible with django-tables2:

<ul>
  <li>Instead of &lt;th scope="row"&gt;, &lt;td class="row-header"&gt; can be used</li>
</ul>